CP(1) | General Commands Manual | CP(1)

# NAME

`cp` —
copy files

# SYNOPSIS

`cp` | [`-R` [`-H` | `-L` | `-P`]] [`-f` | `-i`] [`-alNpv`] source_file target_file

`cp` | [`-R` [`-H` | `-L` | `-P`]] [`-f` | `-i`] [`-alNpv`] source_file ... target_directory

# DESCRIPTION

In the first synopsis form, the `cp` utility copies the contents of the source_file to the target_file. In the second synopsis form, the contents of each named source_file is copied to the destination target_directory. The names of the files themselves are not changed. If `cp` detects an attempt to copy a file to itself, the copy will fail.

The following options are available:

`-a`
  Archive mode. Same as `-RpP`.
`-f`
  For each existing destination pathname, attempt to overwrite it. If permissions do not allow copy to succeed, remove it and create a new file, without prompting for confirmation. (The `-i` option is ignored if the `-f` option is specified.)
`-H`
  If the `-R` option is specified, symbolic links on the command line are followed. (Symbolic links encountered in the tree traversal are not followed.)
`-i`
  Causes `cp` to write a prompt to the standard error output before copying a file that would overwrite an existing file. If the response from the standard input begins with the character ‘`y`’, the file copy is attempted.
`-L`
  If the `-R` option is specified, all symbolic links are followed.
`-l`
  Create hard links to regular files in a hierarchy instead of copying.
`-N`
  When used with `-p`, don't copy file flags.
`-P`
  No symbolic links are followed. This is the default.
`-p`
  Causes `cp` to preserve in the copy as many of the modification time, access time, file flags, file mode, user ID, group ID, and extended attributes, as allowed by permissions.

  If the user ID and group ID cannot be preserved due to insufficient permissions, no error message is displayed and the exit value is not altered.

  If the source file has its set user ID bit on and the user ID cannot be preserved, the set user ID bit is not preserved in the copy's permissions. If the source file has its set group ID bit on and the group ID cannot be preserved, the set group ID bit is not preserved in the copy's permissions. If the source file has both its set user ID and set group ID bits on, and either the user ID or group ID cannot be preserved, neither the set user ID or set group ID bits are preserved in the copy's permissions.

  Extended attributes from all accessible namespaces are copied; others are ignored. If an error occurs during this copy, a message is displayed and `cp` skips the other extended attributes for that file.

`-R`
  If source_file designates a directory, `cp` copies the directory and the entire subtree connected at that point. This option also causes symbolic links to be copied, rather than followed, and for `cp` to create special files rather than copying them as normal files. Created directories have the same mode as the corresponding source directory, unmodified by the process's umask.

  Note that `cp` copies hard linked files as separate files. If you need to preserve hard links, consider using a utility like pax(1) instead.

`-v`
  Causes `cp` to be verbose, showing files as they are copied.

For each destination file that already exists, its contents are overwritten if permissions allow, but its mode, user ID, and group ID are unchanged.

In the second synopsis form, target_directory must exist unless there is only one named source_file which is a directory and the `-R` flag is specified.

If the destination file does not exist, the mode of the source file is used as modified by the file mode creation mask (`umask`, see csh(1)). If the source file has its set user ID bit on, that bit is removed unless both the source file and the destination file are owned by the same user. If the source file has its set group ID bit on, that bit is removed unless both the source file and the destination file are in the same group and the user is a member of that group. If both the set user ID and set group ID bits are set, all of the above conditions must be fulfilled or both bits are removed.

Appropriate permissions are required for file creation or overwriting.

Symbolic links are always followed unless the `-R` flag is set, in which case symbolic links are not followed, by default. The `-H` or `-L` flags (in conjunction with the `-R` flag), as well as the `-P` flag cause symbolic links to be followed as described above. The `-H` and `-L` options are ignored unless the `-R` option is specified. In addition, these options override each other and the command's actions are determined by the last one specified. The default is as if the `-P` option had been specified.

# EXIT STATUS

The `cp` utility exits 0 on success, and >0 if an error occurs.

# COMPATIBILITY

Historic versions of the `cp` utility had a `-r` option. This implementation supports that option, however, its use is strongly discouraged, as it does not correctly copy special files, symbolic links, or FIFOs.

# SEE ALSO

mv(1), pax(1), rcp(1), umask(2), fts(3), symlink(7)

# STANDARDS

The `cp` utility is expected to be IEEE Std 1003.2 (“POSIX.2”) compatible.

The `-a` and `-l` flags are non-standard extensions. They are intended to be compatible with the same options which other implementations, namely GNU coreutils and FreeBSD, of this utility have.

The `-v` option is an extension to IEEE Std 1003.2 (“POSIX.2”).

# HISTORY

A `cp` utility appeared in Version 1 AT&T UNIX.

December 22, 2018 | NetBSD 9.2